include 'mkl/lapack.f90'

program comparison

use LAPACK95, only: GESV
use sparse_solve

implicit none

! --- Declaration
integer :: i
real(8), allocatable :: A(:,:),A1(:,:),Avec(:),b(:),x1(:),x2(:)

! --- Body

! Create arrays
allocate(A(14,14),A1(14,14),Avec(196),b(14),x1(14),x2(14))
open(unit=1, file='Avec.txt', status='old')
do i=1,196
    read(1,*) Avec(i)
end do
close(unit=1)
A=reshape(Avec,(/14,14/))
deallocate(Avec)
open(unit=2, file='b.txt', status='old')
do i=1,14
    read(2,*) b(i)
end do    
close(unit=2)

!! Alternative simple example (both solutions are the same)
!allocate(A(5,5),A1(5,5),b(5),x1(5),x2(5))
!A=reshape((/1,-2,0,-4,0,-1,5,0,0,8,0,0,4,2,0,-3,0,6,7,0,0,0,4,0,-5/),(/5,5/))
!b=(/1,2,3,4,5/)

! GESV
A1=A
x1=b
print*, 'GESV'
print*, '----'
call GESV(A1,x1)
print*, '||Ax-b|| = ', maxval(abs(matmul(A,x1)-b))
print*, char(10)

! PARDISO
print*, 'PARDISO'
print*, '-------'
x2=sparse(A,b)
print*, '||Ax-b|| = ', maxval(abs(matmul(A,x2)-b))
print*, char(10)

! Print solution vectors
print*, 'Solution vectors from GESV and PARDISO'
print*, '--------------------------------------'
do i=1,size(b)
    print*, x1(i), x2(i)
end do
deallocate(A,A1,b,x1,x2)

read*

end program comparison